package org.vaadin.topic.p18482400.ui;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import com.vaadin.flow.component.dependency.CssImport;
import com.vaadin.flow.component.orderedlayout.FlexComponent;
import com.vaadin.flow.component.orderedlayout.VerticalLayout;
import com.vaadin.flow.router.Route;
import com.vaadin.componentfactory.MultipleSelect;

/**
*
*/
@Route(value = "", layout = MainLayout.class)
@CssImport("./styles/shared-styles.css")
public class MainView extends VerticalLayout {
	// Variables.
	private static final long serialVersionUID = 1L;
	private static int LIST_LENGTH = 10;
	@SuppressWarnings("unused")
	private List<AnyBean> selectedItems;

	public MainView() {
		//
		setSizeFull();
		setAlignItems(FlexComponent.Alignment.CENTER);
		setJustifyContentMode(FlexComponent.JustifyContentMode.CENTER);
		setDefaultHorizontalComponentAlignment(FlexComponent.Alignment.CENTER);

		final List<ListValue<AnyBean>> values = getListValues();
		final MultipleSelect<ListValue<AnyBean>> multipleSelect = new MultipleSelect<ListValue<AnyBean>>();
		multipleSelect.setSizeUndefined();
		multipleSelect.setId("multiple-select");
		multipleSelect.setItems(values);
		multipleSelect.addSelectionListener(event -> {
			final Set<ListValue<AnyBean>> list = event.getAllSelectedItems();
			if (list != null && list.size() > 0) {
				final List<AnyBean> tmp = new ArrayList<AnyBean>();
				for (final ListValue<AnyBean> value : list) {
					tmp.add(value.getValue());
				}
				selectedItems = tmp;
			} else {
				selectedItems = null;
			}
		});
		multipleSelect.setLabel("Select");
		multipleSelect.setEmptySelectionAllowed(false);

		add(multipleSelect);
	}

	private List<ListValue<AnyBean>> getListValues() {
		//
		final List<AnyBean> beans = new ArrayList<AnyBean>();
		for (int i = 0; i < LIST_LENGTH; i++) {
			beans.add(new AnyBean(i));
		}
		final List<ListValue<AnyBean>> list = new ArrayList<ListValue<AnyBean>>();
		for (final AnyBean bean : beans) {
			list.add(new ListValue<AnyBean>("Text " + String.valueOf(bean.getValue()), bean));
		}

		return list;
	}
}
